unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, NoiseUnit, ComCtrls;

type
  TFrameForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label3: TLabel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    Edit8: TEdit;
    Button2: TButton;
    Label9: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label10: TLabel;
    Label11: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    Drawing: Integer;
    DragPoint: TPoint;
    MovePoint: TPoint;
  public
    { Public 錾 }
    Gradation: array[0..255] of TColor;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.Button1Click(Sender: TObject);
var
  N, R: Integer;
  Persistence, PStart, Step: Double;
begin
  N := UpDown2.Position;
  R := MakeGradation(clWhite, clBlue, N, Gradation);
  if R = N then
  begin
    try
      Persistence := StrToFloat(Edit4.Text);
    except
      Persistence := 0.5;
      Edit4.Text := '0.5';
    end;

    try
      PStart := StrToFloat(Edit5.Text);
    except
      PStart := 0;
      Edit5.Text := '0';
    end;

    try
      Step := StrToFloat(Edit6.Text);
    except
      Step := 0.03;
      Edit6.Text := '0.03';
    end;

    try
      pUpper := StrToFloat(Edit7.Text);
    except
      pUpper := 0.9;
      Edit7.Text := '0.9';
    end;

    try
      pLower := StrToFloat(Edit8.Text);
    except
      pLower := 0.1;
      Edit8.Text := '0.1';
    end;

    { Perlin Noise ̃o[W߂B}
    if RadioButton1.Checked then
      pVersion := 1985
    else
      pVersion := 2002;

    GridDraw(Image1, Point(0, 0), Point(562, 402), UpDown1.Position, N,
             UpDown3.Position, Persistence, PStart, Step, Gradation, -1);
  end;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  NoiseUnit.pDimension := 2; // 1985 Version p
  ClientWidth := 564;
  ClientHeight := 521;
  Image1.Picture := Nil;
  Image1.Picture.Bitmap.Width := Image1.Width;
  Image1.Picture.Bitmap.Height := Image1.Height;
  Image1.Canvas.Pen.Color := clBlue;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Brush.Color := clBlue;
  Image1.Canvas.Brush.Style := bsSolid;

  Drawing := -1;
  Button1Click(Sender);
  Drawing := 0;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  UpDown1.Position := 3;
  UpDown2.Position := 128;
  UpDown3.Position := 3;
  Edit4.Text := '0.5';
  Edit5.Text := '0';
  Edit6.Text := '0.03';
  Edit7.Text := '0.9';
  Edit8.Text := '0.1';
  Edit9.Text := '5';
  Edit10.Text := '0.03';
  RadioButton2.Checked := True;
  Button1Click(Sender);
end;

procedure TFrameForm.RadioButton1Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.RadioButton2Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DragPoint := Point(X, Y);
  if Drawing = 0 then
  begin
    Drawing := 1; // `Jn
    Image1.Canvas.MoveTo(X, Y);
    MovePoint := DragPoint;
    Image1.Canvas.Pen.Color := clBlack;
    Image1.Canvas.Pen.Width := 2;
    Image1.Canvas.Pen.Mode := pmNotXor;
  end;
end;

procedure TFrameForm.Image1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if Drawing = 1 then
  begin
    Image1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, DragPoint.Y);
    
    MovePoint := Point(X, Y);
    Image1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, DragPoint.Y);
  end;
end;

procedure TFrameForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ANoise: Integer;
  Scale: Double;
begin
  if Drawing = 1 then
  begin
    Image1.Canvas.MoveTo(DragPoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, DragPoint.Y);
    Image1.Canvas.LineTo(MovePoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, MovePoint.Y);
    Image1.Canvas.LineTo(DragPoint.X, DragPoint.Y);

    Image1.Canvas.Pen.Color := clBlack;
    Image1.Canvas.Pen.Width := 2;
    Image1.Canvas.Pen.Mode := pmCopy;

    try
      pUpper := StrToFloat(Edit7.Text);
    except
      pUpper := 0.9;
      Edit7.Text := '0.9';
    end;

    try
      pLower := StrToFloat(Edit8.Text);
    except
      pLower := 0.1;
      Edit8.Text := '0.1';
    end;

    try
      ANoise := StrToInt(Edit9.Text);
    except
      ANoise := 5;
      Edit9.Text := '5';
    end;

    try
      Scale := StrToFloat(Edit10.Text);
    except
      Scale := 0.03;
      Edit10.Text := '0.03';
    end;

    Image1.Canvas.Pen.Color := clBlue;
    Image1.Canvas.Brush.Color := clWhite;
    { t[nh̒`` }
    {FreeRectangle(Image1,
                  DragPoint,
                  MovePoint,
                  ANoise,
                  Scale,
                  fillCloud or fillBorder);}

    { t[nh̑ȉ~` }
    FreeEllipse(Image1,
                DragPoint,
                MovePoint,
                ANoise,
                Scale,
                fillCloud or fillBorder);

    Image1.Canvas.Pen.Width := 1;
    Drawing := 0;
  end;
end;

end.
