unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, NoiseUnit, ExtCtrls;

type
  PDoublePoint = ^TDoublePoint;
  TDoublePoint = record
    X: Double;
    Y: Double;
  end;

  TFrameForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit5: TEdit;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    Edit7: TEdit;
    Label9: TLabel;
    Edit8: TEdit;
    Label10: TLabel;
    Panel2: TPanel;
    Image1: TImage;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label11: TLabel;
    Button2: TButton;
    Button3: TButton;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit3KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit4KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Edit5KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit6KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit7KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit8KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    W, H: Integer; // Canvas ̑傫(E)
    DW, DH: Double; // fʂ̑傫(E)
    LT, RB: TPoint; // Canvas ̍ƉËʒu
    LL, TT, RR, BB: Double; // fʏ̍AAEA̒l
    DLT, DRB: TDoublePoint; // fʏ̍ƉËʒu
    Step: Integer; // Canvas ̃XebṽsNZ
    DStep: Double; // fʏ̃XebṽTCY
  public
    { Public 錾 }
    function DoublePoint(AX, AY: Double): TDoublePoint;
    function C2D(P: TPoint): TDoublePoint;
    function D2C(DP: TDoublePoint): TPoint;
    procedure DMoveTo(X, Y: Double);
    procedure DLineTo(X, Y: Double);
    procedure DTextOut(X, Y: Double; Text: String);
    procedure DrawNoise;
    procedure Init(pW: Integer; pC, bC: TColor);
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

function TFrameForm.DoublePoint(AX, AY: Double): TDoublePoint;
begin
  with Result do
  begin
    X := AX;
    Y := AY;
  end;
end;

function TFrameForm.C2D(P: TPoint): TDoublePoint;
begin
  Result.X := DLT.X + DW * (P.X - LT.X) / W;
  Result.Y := DLT.Y - DH * (P.Y - LT.Y) / H;
end;

function TFrameForm.D2C(DP: TDoublePoint): TPoint;
begin
  Result.X := LT.X + Round(W * (DP.X - DLT.X) / DW);
  Result.Y := LT.Y + Round(H * (DLT.Y - DP.Y) / DH);
end;

procedure TFrameForm.DMoveTo(X, Y: Double);
var
  P: TPoint;
begin
  P := D2C(DoublePoint(X, Y));
  Image1.Canvas.MoveTo(P.X, P.Y);
end;

procedure TFrameForm.DLineTo(X, Y: Double);
var
  P: TPoint;
begin
  P := D2C(DoublePoint(X, Y));
  Image1.Canvas.LineTo(P.X, P.Y);
end;

procedure TFrameForm.DTextOut(X, Y: Double; Text: String);
var
  P: TPoint;
begin
  P := D2C(DoublePoint(X, Y));
  Image1.Canvas.TextOut(P.X, P.Y, Text);
end;

procedure TFrameForm.DrawNoise;
var
  x, y, g: Double;
  px, py, pz: Double;
  i: Integer;
begin
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));

  px := StrToFloat(Edit2.Text);
  py := StrToFloat(Edit3.Text);
  pz := StrToFloat(Edit4.Text);

  if CheckBox1.Checked then
  begin
    Image1.Canvas.Pen.Color := clRed;
    x := DLT.X; // ł́Apx ̂ݕωB
    if CheckBox4.Checked then
      y := opnoise(5, 0.5, x, py, pz)
    else
      y := noise(x, py, pz);
    DMoveTo(x, y);
    x := x + DStep;
    while x <= DRB.X do
    begin
      if CheckBox4.Checked then
        y := opnoise(5, 0.5, x, py, pz)
      else
        y := noise(x, py, pz);
      DLineTo(x, y);
      x := x + DStep;
    end;
  end;

  if CheckBox2.Checked then
  begin
    Image1.Canvas.Pen.Color := clGreen;
    x := DLT.X; // ł́Apy ̂ݕωB
    if CheckBox4.Checked then
      y := opnoise(5, 0.5, px, x, pz)
    else
      y := noise(px, x, pz);
    DMoveTo(x, y);
    x := x + DStep;
    while x <= DRB.X do
    begin
      if CheckBox4.Checked then
        y := opnoise(5, 0.5, px, x, pz)
      else
        y := noise(px, x, pz);
      DLineTo(x, y);
      x := x + DStep;
    end;
  end;

  if CheckBox3.Checked then
  begin
    Image1.Canvas.Pen.Color := clBlue;
    x := DLT.X; // ł́Apz ̂ݕωB
    if CheckBox4.Checked then
      y := opnoise(5, 0.5, px, py, x)
    else
      y := noise(px, py, x);
    DMoveTo(x, y);
    x := x + DStep;
    while x <= DRB.X do
    begin
      if CheckBox4.Checked then
        y := opnoise(5, 0.5, px, py, x)
      else
        y := noise(px, py, x);
      DLineTo(x, y);
      x := x + DStep;
    end;
  end;

  Image1.Canvas.Pen.Color := clBlack;
  DMoveTo(LL, 0);
  DLineTo(RR, 0);
  DMoveTo(0, TT);
  DLineTo(0, BB);

  g := TT / 50;
  for i := Round(LL) to Round(RR) do
  begin
    DMoveTo(i, g);
    DLineTo(i, -g);
    Image1.Canvas.Font.Size := 12;
    Image1.Canvas.Font.Style := [fsBold];
    DTextOut(i - 0.02, -0.01, IntToStr(i));
  end;

  DTextOut(LL + 0.12, 0.5 + 0.02, '0.5');
  DMoveTo(LL, 0.5);
  DLineTo(LL + 0.08, 0.5);

  DTextOut(RR - 0.26, 0.5 + 0.02, '0.5');
  DMoveTo(RR, 0.5);
  DLineTo(RR - 0.08, 0.5);
end;

{ eϐ̒l Canvas 葱łB}
{ pW : `悷̑ }
{ pC : `悷̐F }
{ bC : Canvas ̔wi̐F }

procedure TFrameForm.Init(pW: Integer; pC, bC: TColor);
begin
  { Canvas ̑傫 }
  W := Image1.Width;
  H := Image1.Height;
  LT := Point(0, 0);
  RB := Point(W - 1, H - 1);

  { fʂ̑傫 }
  LL := StrToFloat(Edit5.Text);
  TT := StrToFloat(Edit6.Text);
  RR := StrToFloat(Edit7.Text);
  BB := StrToFloat(Edit8.Text);
  DW := RR - LL;
  DH := TT - BB;
  DLT := DoublePoint(LL, TT);
  DRB := DoublePoint(RR, BB);

  { `̃Xebv }
  Step := 2; // Canvas ̃XebṽsNZ
  DStep := Step * DW / W; // fʏ̃XebṽTCY

  Image1.Picture := Nil;
  Image1.Picture.Bitmap.Width := W;
  Image1.Picture.Bitmap.Height := H;
  Image1.Canvas.Pen.Color := pC;
  Image1.Canvas.Pen.Width := pW;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Brush.Color := bC;
  Image1.Canvas.Brush.Style := bsSolid;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
 x, y, z, v: Double;
begin
  Init(2, clBlack, clWhite);
  DrawNoise;

  x := StrToFloat(Edit2.Text);
  y := StrToFloat(Edit3.Text);
  z := StrToFloat(Edit4.Text);
  if CheckBox4.Checked then
    v := opnoise(5, 0.5, x, y, z)
  else
    v := noise(x, y, z);
  Edit1.Text := Format('%.17f', [v]);
end;

procedure TFrameForm.Edit2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.Edit3KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.Edit4KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.FormResize(Sender: TObject);
begin
  if Tag <> 0 then
    Button1Click(Sender);
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  Tag := 1;
  ClientWidth := 672;
  ClientHeight := 512;
end;

procedure TFrameForm.Edit5KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.Edit6KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.Edit7KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.Edit8KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = $0D then
    Button1Click(Sender);
end;

procedure TFrameForm.CheckBox1Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox2Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox3Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.Button2Click(Sender: TObject);
var
  D: Double;
begin
  D := RR - LL;
  LL := LL - D;
  Edit5.Text := FloatToStr(LL);
  RR := RR - D;
  Edit7.Text := FloatToStr(RR);
  Button1Click(Sender);
end;

procedure TFrameForm.Button3Click(Sender: TObject);
var
  D: Double;
begin
  D := RR - LL;
  LL := LL + D;
  Edit5.Text := FloatToStr(LL);
  RR := RR + D;
  Edit7.Text := FloatToStr(RR);
  Button1Click(Sender);
end;

procedure TFrameForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  DP: TDoublePoint;
begin
  DP := C2D(Point(X, Y));
  Caption := 'Perlin Noise  (x,  y)  =  (' + Format('%.3f', [DP.X]) + ',   ' + Format('%.3f', [DP.Y]) + ')';
end;

procedure TFrameForm.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
    NoiseUnit.pVersion := 1985
  else
    NoiseUnit.pVersion := 2002;
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked then
    Label1.Caption := 'opnoise(5, 0.5, x, y, z) ='
  else
    Label1.Caption := '           noise(x, y, z) =';

  Button1Click(Sender);
end;

procedure TFrameForm.Button4Click(Sender: TObject);
var
  x, y, step: Double;
  px, py, pz: Double;
  vmin, vmax: Double;
  S: String;
begin
  px := StrToFloat(Edit2.Text);
  py := StrToFloat(Edit3.Text);
  pz := StrToFloat(Edit4.Text);
  step := 0.01;
  S := '//////////   ݂̐ݒŊemCY֐Ԃl͈̔   //////////' + #10#13 + #10#13 + #10#13;

  vmin := 1;
  vmax := -1;

  x := 0;
  while x <= 255 do
  begin
    y := Perlin(x, py, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := Perlin(px, x, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := Perlin(px, py, x);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    x := x + step;
  end;

  S := S + 'Perlin(x, y, z)  =  ' + FloatToStr(vmin) + '  `  ' + FloatToStr(vmax) + #10#13 + #10#13;

  x := 0;
  while x <= 255 do
  begin
    y := pPerlin(x, py, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := pPerlin(px, x, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := pPerlin(px, py, x);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    x := x + step;
  end;

  S := S + 'pPerlin(x, y, z)  =  ' + FloatToStr(vmin) + '  `  ' + FloatToStr(vmax) + #10#13 + #10#13;

  vmin := 1;
  vmax := 0;

  x := 0;
  while x <= 255 do
  begin
    y := noise(x, py, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := noise(px, x, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := noise(px, py, x);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    x := x + step;
  end;

  S := S + 'noise(x, y, z)  =  ' + FloatToStr(vmin) + '  `  ' + FloatToStr(vmax) + #10#13 + #10#13;

  x := 0;
  while x <= 255 do
  begin
    y := opnoise(5, 0.5, x, py, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := opnoise(5, 0.5, px, x, pz);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    y := opnoise(5, 0.5, px, py, x);
    if y < vmin then vmin := y;
    if y > vmax then vmax := y;

    x := x + step;
  end;

  S := S + 'opnoise(5, 0.5, x, y, z)  =  ' + FloatToStr(vmin) + '  `  ' + FloatToStr(vmax) + #10#13 + #10#13;

  ShowMessage(S);
end;

end.
