unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, NoiseUnit;

type
  TFrameForm = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Image1: TImage;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Label4: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    Gradation: array[0..255] of TColor;
    procedure DrawGradation;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.DrawGradation;
var
  X, N: Integer;
begin
  N := MakeGradation(Panel1.Color, Panel2.Color, 256, Gradation);

  if N = 256 then
  begin
    for X := 0 to 255 do
    begin
      Image1.Canvas.Pen.Color := Gradation[X];
      Image1.Canvas.MoveTo(X, 0);
      Image1.Canvas.LineTo(X, 256);
    end;
    Label1.Caption := Format('$%8.8x', [Integer(Panel1.Color)]);
    Label2.Caption := Format('$%8.8x', [Integer(Panel2.Color)]);
    Panel3.Color := Gradation[127];
    Label3.Caption := Format('$%8.8x', [Integer(Panel3.Color)]);
  end;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    Panel1.Color := Integer(ColorDialog1.Color) and $00FFFFFF;
    DrawGradation;
  end;
end;

procedure TFrameForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Col: TColor;
begin
  Col := Image1.Canvas.Pixels[X, Y];
  Panel3.Color := Col;
  Label3.Caption := Format('$%8.8x', [Integer(Col)]);
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    Panel2.Color := Integer(ColorDialog1.Color) and $00FFFFFF;
    DrawGradation;
  end;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  ClientWidth := 290;
  ClientHeight := 418;
  DrawGradation;
end;

end.
